 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: __HaveNTRights                                    */
 /*                                                               */
 /*   Descrip:  If the user does not have rights to update        */
 /*             Registry then a TRUE will be returned             */
 /*             Otherwise a FALSE is returned                     */
 /*                                                               */ 
 /*---------------------------------------------------------------*/

prototype _HaveNTRights( );

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _TimeoutExpired                                   */
 /*                                                               */
 /*   Descrip:  If the cuurent system date is after the           */
 /*             the date passed in, then a TRUE will be           */
 /*             returned. Otherwise a FALSE is returned           */
 /*                                                               */ 
 /*---------------------------------------------------------------*/

 prototype _TimeoutExpired (INT, INT, INT);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _ExitifSameSetupActive                            */
 /*                                                               */
 /*   Descrip:  if the same install is already running, exit      */ 
 /*             so as to avoid multiple setups running            */
 /*             at the same time.                                 */
 /*                                                               */ 
 /*   Misc:    use the main window title (BACKGROUNDCAPTION)      */
 /*            presumably set during _SetupScreen                 */
 /*                                                               */
 /*---------------------------------------------------------------*/

 prototype _ExitIfSameSetupActive  ( STRING );

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _DisplayLicense                                   */
 /*                                                               */
 /*   Descrip:  This dialog will ask the user to agree with       */
 /*             the terms of license agreement.                   */
 /*   Misc:     This functions assumes that license.txt is        */
 /*             compressed into _setup.lib.                       */
 /*             if the parameters are NULL, it displays           */
 /*             the following messages for Title, Message and     */
 /*             Question.                                         */
 /*                                                               */
 /*---------------------------------------------------------------*/

 prototype _DisplayLicense (STRING, STRING, STRING);

 /*--------------------------------------------------------------*/
 /*                                                              */
 /*   Function: _GenLib_ModLicense                               */
 /*                                                              */
 /*   Descrip:  This dialog will ask the user to agree with      */
 /*             the terms of a license agreement.                */
 /*             This function is derived from ISHEILD SdLic.rul, */
 /*             the added functinality is to change the 'YES/NO' */
 /*             buttons to 'I Accept/Decline' buttons and the    */
 /*             lincense text and buttons text is set to BOLD.   */
 /*   Misc:     Internal function used by _DisplayLicense.       */
 /*                                                              */
 /*--------------------------------------------------------------*/

prototype _GenLib_ModLicense( STRING, STRING, STRING, STRING );

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _CheckComponentVersion                            */
 /*                                                               */
 /*   Descrip: to check versions of files.                        */
 /*            Checks to see if source file (in SRCDIR) already   */
 /*            exists in TARGETDIR, and if so how new or old.     */
 /*   Input:	szSrc  = Source file name                         */
 /*             szDest = Target file name                         */
 /*                                                               */ 
 /*   Misc:   Returns                                             */
 /*          0 - file does not exist in TARGETDIR                 */
 /*          1 - file in TARGETDIR is newer than one in SRCDIR    */
 /*          2 - file in TARGETDIR is same age as one in SRCDIR   */
 /*          3 - file in TARGETDIR is older than one in SRCDIR    */
 /*         -1 if unsuccessful(source file does not exist)        */
 /*                                                               */
 /*---------------------------------------------------------------*/

prototype _CheckComponentVersion(STRING, STRING);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _GetProgFilesPath                                 */
 /*                                                               */
 /*   Descrip: retrieves ProgramFiles directory from the          */ 
 /*            registry. For some reason, if the registry         */
 /*            function fails, it defaults to                     */
 /*            <windows driver>:\Program Files.                   */
 /*                                                               */
 /*      Misc:  Always returns TRUE                               */
 /*                                                               */
 /*---------------------------------------------------------------*/

prototype _GetProgFilesPath ( BYREF STRING );

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _DelKeyIfnoSubKey                                 */
 /*                                                               */
 /*   Descrip:  Deletes registry key if there are no              */ 
 /*             defined subkeys under the given key               */
 /*                                                               */
 /*      Misc:  returns                                           */
 /*                       0  - success                            */
 /*                      <0  - failure                            */
 /*     GENLIB_MEMALLOC_ERR  - unable to allocate memory          */
 /*     GENLIB_FUNC_ERR (-1) - registry functions failed          */
 /*                                                               */
 /*---------------------------------------------------------------*/


prototype _DelKeyIfnoSubKey(INT, STRING);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _DeleteRegKeyValue                                */
 /*                                                               */
 /*   Descrip: Deletes a string and the corresponding value under */ 
 /*            the subkey. This is a work around function as      */
 /*            there is ISHIELD function to do this.              */
 /*                                                               */
 /*      Misc:   returns                                          */
 /*             GENLIB_FUNC_OKAY (0) - on success                 */
 /*             otherwise returns one of the following (<0)       */
 /*             GENLIB_MEMALLOC_ERR                               */
 /*             GENLIB_FUNC_ERR (-1)                              */
 /*             GENLIB_NOSTRINGS_ERR                              */
 /*                                                               */
 /*                                                               */
 /*---------------------------------------------------------------*/

prototype _DeleteRegKeyValue(INT, STRING, STRING);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _ActualCopy                                       */
 /*                                                               */
 /*   Descrip:  This function is same as CopyFile with Error      */ 
 /*             checking.                                         */
 /*                                                               */
 /*      Misc: the Ishield system constants SRCDIR and TARGETDIR  */
 /*            are used to determine source and destination       */
 /*            directories                                        */
 /*            Returns                                            */
 /*              GENLIB_FUNC_OKAY (0) - on sucesss                */
 /*              otherwise returns one of the following (<0)      */
 /*                                                               */
 /*                                                               */
 /*---------------------------------------------------------------*/


prototype _ActualCopy (STRING, STRING);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _GetAndCopyFiles                                  */
 /*                                                               */
 /*   Descrip:  CompressGet plus Error Checking and in case core  */ 
 /*             (bCore =TRUE) dlls copy, it disables logging.     */
 /*                                                               */
 /*      Misc:  Returns                                           */
 /*             GENLIB_FUNC_OKAY (0) - on success                 */
 /*             otherwise returns <0.                             */
 /*                                                               */
 /*---------------------------------------------------------------*/

prototype _GetAndCopyFiles( STRING, STRING, STRING, INT, BOOL);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _LauncReadmeApp                                   */
 /*                                                               */
 /*   Descrip: To lauch a veiwer associated with the given        */
 /*            document.                                          */ 
 /*                                                               */
 /*      Misc: if user specifies the viewer for the document      */
 /*            the function verifies the existance of the viewer  */
 /*            and if avialable  executes it. Otherwise it        */
 /*            retrieves the default viewer associated with the   */
 /*            document from the registry using class definitions */ 
 /*                                                               */
 /*---------------------------------------------------------------*/

prototype _LaunchReadmeApp(STRING, STRING);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _SearchFileOnAllLocalDisks (szApp, svAppFullPath) */
 /*                                                               */
 /*   Descrip: Search all local disk for given file and return    */ 
 /*            full path of first occurance of the given file.    */
 /*                                                               */
 /*      Misc:                                                    */
 /*                                                               */
 /*---------------------------------------------------------------*/

prototype _SearchFileOnAllLocalDisks (STRING, BYREF STRING );

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _GetAppForExtension                               */
 /*                                                               */
 /*   Descrip: based on the class definition in the registry      */ 
 /*            and/or win.ini, retrieve the application(viewer)   */
 /*            associated with the given file extension.          */
 /*                                                               */
 /*      Misc:                                                    */
 /*                                                               */
 /*---------------------------------------------------------------*/


prototype _GetAppForExtention ( STRING, BYREF STRING);

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _RegAddVxDEntry                                   */
 /*                                                               */
 /*   Descrip:  add static vxd entry to the registry              */ 
 /*                                                               */
 /*      Misc: windows 95 equivalent to adding Device= "VXD" in   */
 /*            [386 Enh] section of system.ini                    */
 /*                                                               */
 /*---------------------------------------------------------------*/


prototype _RegAddVxDEntry ( STRING, STRING );


 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _WaitOnAcrobatInstaller                           */
 /*                                                               */
 /*   Descrip:  The function waits for acrobat installer to       */
 /*             finish by checking for the presence of acrobat    */
 /*             installer windows using window captions used by   */
 /*             acrobat installer.                                */ 
 /*                                                               */
 /*      Misc: in few cases, there may be a race condition and    */
 /*            this function may return before acrobat            */
 /*            installation is complete.                          */
 /*            Internal function used _InstallAcrobatAndWait.     */
 /*                                                               */
 /*---------------------------------------------------------------*/


prototype _WaitOnAcrobatInstaller();

 /*---------------------------------------------------------------*/
 /*                                                               */
 /*   Function: _InstallAcrobatAndWait                            */
 /*                                                               */
 /*   Descrip: This function invokes acrobat installer from the   */
 /*            given directory and waits for acrobat installer to */
 /*            complete.                                          */ 
 /*                                                               */
 /*      Misc: in some cases,                                     */
 /*              this function may return before acrobat          */
 /*              installion is complete.                          */
 /*             or                                                */
 /*              there may be some delay after the acrobat        */
 /*              installer is terminated.                         */
 /*                                                               */
 /*---------------------------------------------------------------*/

prototype _InstallAcrobatAndWait(STRING);

#define GENLIB_FUNC_OKAY             0
#define GENLIB_GETVER_TARGETNEWER   1
#define GENLIB_GETVER_TARGETOLDER   3
#define GENLIB_GETVER_TARGETSAME    2
#define GENLIB_GETVER_NOTARGETFILE  0
#define GENLIB_FUNC_ERR            -1
#define GENLIB_MEMALLOC_ERR        -1000
#define GENLIB_NOSTRINGS_ERR       -1001
#define GENLIB_NODOCUMENT          -1002
#define GENLIB_NODEFAULT_VIEWER    -1003
#define GENLIB_LAUNCHAPP_FAILED    -1004

#define GENLIB_ACROBAT_WINDOW_TITLE   "Acrobat Installer"
#define GENLIB_ACROBAT_WINDOW_TITLE2  "Electronic End User License Agreement"
#define ONE_MIN_WAIT   10000
#define MSG_NOREG_ACCESS	"You do not have sufficient rights to install this program.\nPlease contact your system administrator."
