
#define INDOUNIN_VERSION "1.00.000"

#include <windows.h>
#include <stdio.h>

typedef WORD version_info[4];

static BOOL GetVersionOfFile(char *FileName,version_info ret)
{
	unsigned long newsize,dummy;

	if (newsize=GetFileVersionInfoSize(FileName,&dummy)) {
		static unsigned long size = 0;
		static void *versioninfo = 0;
		void *ptr_to_fixed_info;
		unsigned int length;

		if (newsize > size)
			versioninfo = size ? realloc(versioninfo,size=newsize) : malloc(size=newsize);

		if (GetFileVersionInfo(FileName,0,size,versioninfo)) {
			if (ret) {
				if (VerQueryValue(versioninfo,TEXT("\\"),&ptr_to_fixed_info,&length)) {
					VS_FIXEDFILEINFO fixed_info = *((VS_FIXEDFILEINFO *)ptr_to_fixed_info);
					ret[0] = (WORD) (fixed_info.dwProductVersionMS >> 16);
					ret[1] = (WORD) (fixed_info.dwProductVersionMS & 0xffff);
					ret[2] = (WORD) (fixed_info.dwProductVersionLS >> 16);
					ret[3] = (WORD) (fixed_info.dwProductVersionLS & 0xffff);
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}

static bool SameVersion(char *version,char *filename)
{
	version_info vi;

	if (GetVersionOfFile(filename,vi)) {
		char buff[MAX_PATH];
		sprintf(buff,"%d.%d.%d.%d",vi[0],vi[1],vi[2],vi[3]);
		return strcmp(version,buff) == 0;
	}
	return FALSE;
}

#define TRIM_STR(X) (X)[strlen((char *)(X))-1] = 0

LONG UninstInitialize(HWND hwndDlg,HINSTANCE hInstance,LONG lReserved)
{
	HKEY indeosoftwarekey;
#ifdef _DEBUG
	__asm { int 3 }
#endif
	if (ERROR_SUCCESS == RegOpenKey(HKEY_LOCAL_MACHINE,"Software\\Intel\\Indeo Software\\" INDOUNIN_VERSION "\\UninstallInfo",
								&indeosoftwarekey)) {
		BYTE indeosavefilespath[MAX_PATH];
		unsigned long typeofreturn,lengthofindeosavefilespath = sizeof(indeosavefilespath);
		if (ERROR_SUCCESS == RegQueryValueEx(indeosoftwarekey,
							"SaveFilesPath",
							NULL,
							&typeofreturn,
							indeosavefilespath,
							&lengthofindeosavefilespath)) {
				BYTE src[MAX_PATH*2];
				FILE *indeosavfilesmap;

				sprintf((char *)src,"%s\\indeosav.map",indeosavefilespath);
				if (indeosavfilesmap = fopen((char *)src,"r")) {
					BYTE temppath[MAX_PATH],ext[MAX_PATH],dst[MAX_PATH*2],versioninfo[MAX_PATH];

					GetTempPath(sizeof(temppath),(char *)temppath);
					// Format of file is:
					//    extension   (e.g. 001)
					//    src location (e.g. c:\windows\system\ir50_32.dll
					//    installed version (e.g. 5.2562.15.48)
					while (!feof(indeosavfilesmap) && fgets((char *)ext,sizeof(ext),indeosavfilesmap)) {
						TRIM_STR(ext);
						sprintf((char *)src,"%s\\indeosav.%s",indeosavefilespath,ext);
						fgets((char *)dst,sizeof(dst),indeosavfilesmap);
						TRIM_STR(dst);
						fgets((char *)versioninfo,sizeof(versioninfo),indeosavfilesmap);
						TRIM_STR(versioninfo);
						if (SameVersion((char *)versioninfo,(char *)dst)) {
							sprintf((char *)dst,"%s\\indeosav.%s",temppath,ext);
							CopyFile((char *)src,(char *)dst,FALSE);
						}
					}
					fclose(indeosavfilesmap);
					sprintf((char *)dst,"%s\\indeosav.map",temppath);
					sprintf((char *)src,"%s\\indeosav.map",indeosavefilespath,ext);
					CopyFile((char *)src,(char *)dst,FALSE);
					unlink((char *)src);
				}
		}
		RegCloseKey(indeosoftwarekey);
	}

	return 0;  /* returning 0 means everything is dandy, return a value less than 0 to mean something bad has happened. */
}

#define IS_WINDOWS95()	(GetVersion() & 0x80000000)

static void SelfRegister(char *file,char *temppath,HWND hwndDlg,BOOL bUnregister = FALSE) {
	static char pathtoregsvr32[MAX_PATH] = {0};
	char buff[MAX_PATH*2],*switches;

	if (!pathtoregsvr32[0]) {
		char *regsvr32 = IS_WINDOWS95() ? "9x" : "nt";

		sprintf(pathtoregsvr32,"%s\\rs%s.exe",temppath,regsvr32);
	}
	switches = (bUnregister) ? "/s /u" : "/s";
	sprintf(buff,"%s %s %s",pathtoregsvr32,switches,file);
	ShellExecute(hwndDlg, "open", pathtoregsvr32, buff, "", SW_SHOWNORMAL);
}

static BOOL PutRegistryKeyValue(char *key,char *value_name,char *buff,HKEY hKey = HKEY_LOCAL_MACHINE,BOOL isAString = TRUE)
{
	BOOL ret_val = TRUE;

	ret_val = ERROR_SUCCESS == RegCreateKey(hKey,key,&hKey);

	ret_val = ret_val && (ERROR_SUCCESS == RegSetValueEx(hKey, (LPCSTR) value_name, 0, isAString ? REG_SZ : REG_DWORD, 
		(BYTE*)buff, isAString ? (strlen(buff)+1) : sizeof(DWORD)));
	if (hKey)
		RegCloseKey(hKey);
	return ret_val;
}

enum whichcodec {yvu9, ir41, ir32};

static void Register(char *dest,enum whichcodec which) {
	struct table_entry {
		char *key_name,*value_name,*value;
	};
	struct table_entry yvu9_table_win95[] = {
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.YVU9",
						"Description",
						"Indeo video Raw YVU9 by Intel"},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.YVU9",
                        "Driver",
                        dest},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.YVU9",
                        "FriendlyName",
                        "Indeo video Raw YVU9 by Intel"},
				{NULL,NULL,NULL}
	};
	struct table_entry yvu9_table_nt[] = {
			{"Software\\Microsoft\\Windows NT\\CurrentVersion\\Drivers32",
                        "vidc.yvu9",
                        dest},
			{"Software\\Microsoft\\Windows NT\\CurrentVersion\\drivers.desc",
                        dest,
                        "Indeo video Raw YVU9 by Intel"},
			{NULL,NULL,NULL}
	};

	struct table_entry ir41_table_win95[] = {
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.IR41",
						"Description",
						"Indeo video interactive 4.x by Intel"},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.IR41",
                        "Driver",
                        dest},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.IR41",
                        "FriendlyName",
                        "Indeo video interactive 4.x by Intel"},
			{NULL,NULL,NULL}
	};
	struct table_entry ir41_table_nt[] = {
			{"Software\\Microsoft\\Windows NT\\CurrentVersion\\Drivers32",
                        "vidc.ir41",
                        dest},
			{"Software\\Microsoft\\Windows NT\\CurrentVersion\\drivers.desc",
                        dest,
                        "Indeo video interactive 4.x by Intel"},
			{NULL,NULL,NULL}
	};

	struct table_entry ir32_table_win95[] = {
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.iv32",
						"Description",
						"Indeo video 3.2 by Intel"},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.iv32",
                        "Driver",
                        dest},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.iv32",
                        "FriendlyName",
                        "Indeo video 3.2 by Intel"},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.iv31",
						"Description",
						"Indeo video 3.2 by Intel"},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.iv31",
                        "Driver",
                        dest},
			{"System\\CurrentControlSet\\control\\MediaResources\\icm\\vidc.iv31",
                        "FriendlyName",
                        "Indeo video 3.2 by Intel"},
			{NULL,NULL,NULL}
		};
	struct table_entry ir32_table_nt[] = {
			{"Software\\Microsoft\\Windows NT\\CurrentVersion\\Drivers32",
                        "vidc.iv32",
                        dest},
			{"Software\\Microsoft\\Windows NT\\CurrentVersion\\Drivers32",
                        "vidc.iv31",
                        dest},
			{"Software\\Microsoft\\Windows NT\\CurrentVersion\\drivers.desc",
                        dest,
                        "Indeo video 3.2 by Intel"},
			{NULL,NULL,NULL}
		};
	struct table_entry *reg_table = NULL;
	int i;
	DWORD rv = 0;

	if (IS_WINDOWS95()) {
		char   *vidc_fourcc[3] = {NULL,NULL,NULL};
		TCHAR ShortModuleFilename[MAX_PATH];
		if (which == yvu9) {
			reg_table = yvu9_table_win95;
			vidc_fourcc[0] = "VIDC.YVU9";
		}
		else if (which == ir41) {
			reg_table = ir41_table_win95;
			vidc_fourcc[0] = "VIDC.IV41";
		}
		else if (which == ir32) {
			reg_table = ir32_table_win95;
			vidc_fourcc[0] = "VIDC.iv32";
			vidc_fourcc[1] = "VIDC.iv31";
		}
		GetShortPathName(dest,(LPTSTR)ShortModuleFilename,sizeof(ShortModuleFilename));

		for (i=0;i < 3 && vidc_fourcc[i];i++)
			WritePrivateProfileString("drivers32",
				vidc_fourcc[i], (LPCSTR) ShortModuleFilename, "system.ini");
	}
	else {
		if (which == yvu9) {
			reg_table = yvu9_table_nt;
		}
		else if (which == ir41) {
			reg_table = ir41_table_nt;
		}
		else if (which == ir32) {
			reg_table = ir32_table_nt;
		}
	}

	for (i=0;reg_table && reg_table[i].key_name;i++)
		PutRegistryKeyValue(reg_table[i].key_name,reg_table[i].value_name,reg_table[i].value);
}

static void AddSharedKey(char *fname)
{
	unsigned long one = 1;
	PutRegistryKeyValue("Software\\Microsoft\\Windows\\CurrentVersion\\SharedDLLs",
		fname,(char *) &one,HKEY_LOCAL_MACHINE,FALSE);
}

#include <sys/types.h>
#include <sys/stat.h>

LONG UninstUnInitialize(HWND hwndDlg,HINSTANCE hInstance,LONG lReserved)
{
	BYTE temppath[MAX_PATH],indeosavmap[MAX_PATH];
	FILE *indeosavfilesmap;

#ifdef _DEBUG
	__asm { int 3 }
#endif
	GetTempPath(sizeof(temppath),(char *)temppath);
	sprintf((char *)indeosavmap,"%s\\indeosav.map",temppath);
	if (indeosavfilesmap = fopen((char *)indeosavmap,"r")) {
		BYTE ext[MAX_PATH];
		// Format of file is:
		// {extension}  (e.g. 001
		// {destination file} (e.g. c:\windows\system\ir50_32.dll)
		// {installed version} (e.g. 5.2562.15.48)
		while (!feof(indeosavfilesmap) && fgets((char *)ext,sizeof(ext),indeosavfilesmap) /* Read the extension. */) {
			BYTE src[MAX_PATH],dst[MAX_PATH],installedversion[MAX_PATH];
			struct _stat tmp;

			TRIM_STR(ext);
			sprintf((char *)src,"%s\\indeosav.%s",temppath,ext); 
			fgets((char *)dst,sizeof(dst),indeosavfilesmap);  /* Read the destination. */
			fgets((char *)installedversion,sizeof(installedversion),indeosavfilesmap);
			TRIM_STR(dst);
			if (0 == _stat((char *)src,&tmp)) {  /* if the src file exists then ... */
				if (0 == _stat((char *)dst,&tmp)) {  /* if the destination file exists on the system. ... */
					/* First, unregister the existing codec. */
					switch (toupper(ext[2])) {
						case 'A':  // ir50_32.dll
							SelfRegister((char *)dst,(char *)temppath,hwndDlg,TRUE);
							break;
						case 'B': // indeo5.cnt
							break;
						case 'C': // indeo5.hlp
							break;
						case 'D': // ir50_qc.dll
							break;
						case 'E': // ir50_qcx.dll
							break;
						case 'F': //ivfsrc.ax
							SelfRegister((char *)dst,(char *)temppath,hwndDlg,TRUE);
							break;
						case 'G': // npindeo.dll
							break;
						case 'H': // npindeo.dll
							break;
						case 'I': // npindeo.dll
							break;
						case 'J': // npindeo.dll
							break;
						case 'K': // ir41_32.ax
							SelfRegister((char *)dst,(char *)temppath,hwndDlg);
							break;
						case 'L': // indeo.cnt
							break;
						case 'M': // indeo.hlp
							break;
						case 'N': // ir41_qc.dll
							break;
						case 'O': // ir41_qcx.dll
							break;
						case 'P': // iyvu9_32.dll
							break;
						case 'Q': // iac25_32.dll
							SelfRegister((char *)dst,(char *)temppath,hwndDlg,TRUE);
							break;
						case 'R': // ir32_32.dll
							break;
						case 'S':  // iacenc.dll
							break;
						default:  // Whoops.  SHould never reach here.
							break;
					} /* end switch */
					unlink((char *)dst);
				}  /* if (stat(dst) ... */
				/* Copy the file back. */
				CopyFile((char *)src,(char *)dst,FALSE);
				/* And register the file. */
				switch (toupper(ext[2])) {
					case 'A':  // ir50_32.dll
						SelfRegister((char *)dst,(char *)temppath,hwndDlg);
						AddSharedKey((char *)dst);
						break;
					case 'B': // indeo5.cnt
						break;
					case 'C': // indeo5.hlp
						break;
					case 'D': // ir50_qc.dll
						AddSharedKey((char *)dst);
						break;
					case 'E': // ir50_qcx.dll
						AddSharedKey((char *)dst);
						break;
					case 'F': //ivfsrc.ax
						SelfRegister((char *)dst,(char *)temppath,hwndDlg);
						AddSharedKey((char *)dst);
						break;
					case 'G': // npindeo.dll
						break;
					case 'H': // npindeo.dll
						break;
					case 'I': // npindeo.dll
						break;
					case 'J': // npindeo.dll
						break;
					case 'K': // ir41_32.ax
						SelfRegister((char *)dst,(char *)temppath,hwndDlg);
						Register((char *)dst,ir41);
						//AddSharedKey((char *)dst);
						break;
					case 'L': // indeo.cnt
						break;
					case 'M': // indeo.hlp
						break;
					case 'N': // ir41_qc.dll
						AddSharedKey((char *)dst);
						break;
					case 'O': // ir41_qcx.dll
						AddSharedKey((char *)dst);
						break;
					case 'P': // iyvu9_32.dll
						Register((char*)dst,yvu9);
						AddSharedKey((char *)dst);
						break;
					case 'Q': // iac25_32.dll
						SelfRegister((char *)dst,(char *)temppath,hwndDlg);
						AddSharedKey((char *)dst);
						break;
					case 'R': // ir32_32.dll
						Register((char *)dst,ir32);
						//AddSharedKey((char *)dst);
						break;
					case 'S':  // iacenc.dll
						AddSharedKey((char *)dst);
						break;
					default:  // Whoops.  SHould never reach here.
						break;
				} /* End switch */
			} /* if (stat(src) */
			unlink((char *)src);
		}
		fclose(indeosavfilesmap);
		unlink((char *)indeosavmap);
	}
	return 0;  /* return value is ignored. */
}
